const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class School_adminsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const school_admins = await db.school_admins.create(
      {
        id: data.id || undefined,

        full_name: data.full_name || null,
        phone_number: data.phone_number || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await school_admins.setUser(data.user || null, {
      transaction,
    });

    await school_admins.setSchool(data.school || null, {
      transaction,
    });

    await school_admins.setSchools(data.schools || null, {
      transaction,
    });

    return school_admins;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const school_adminsData = data.map((item, index) => ({
      id: item.id || undefined,

      full_name: item.full_name || null,
      phone_number: item.phone_number || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const school_admins = await db.school_admins.bulkCreate(school_adminsData, {
      transaction,
    });

    // For each item created, replace relation files

    return school_admins;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const school_admins = await db.school_admins.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.full_name !== undefined) updatePayload.full_name = data.full_name;

    if (data.phone_number !== undefined)
      updatePayload.phone_number = data.phone_number;

    updatePayload.updatedById = currentUser.id;

    await school_admins.update(updatePayload, { transaction });

    if (data.user !== undefined) {
      await school_admins.setUser(
        data.user,

        { transaction },
      );
    }

    if (data.school !== undefined) {
      await school_admins.setSchool(
        data.school,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await school_admins.setSchools(
        data.schools,

        { transaction },
      );
    }

    return school_admins;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const school_admins = await db.school_admins.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of school_admins) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of school_admins) {
        await record.destroy({ transaction });
      }
    });

    return school_admins;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const school_admins = await db.school_admins.findByPk(id, options);

    await school_admins.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await school_admins.destroy({
      transaction,
    });

    return school_admins;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const school_admins = await db.school_admins.findOne(
      { where },
      { transaction },
    );

    if (!school_admins) {
      return school_admins;
    }

    const output = school_admins.get({ plain: true });

    output.user = await school_admins.getUser({
      transaction,
    });

    output.school = await school_admins.getSchool({
      transaction,
    });

    output.schools = await school_admins.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.users,
        as: 'user',

        where: filter.user
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.user
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.user
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.schools,
        as: 'school',
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.full_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('school_admins', 'full_name', filter.full_name),
        };
      }

      if (filter.phone_number) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'school_admins',
            'phone_number',
            filter.phone_number,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.school) {
        const listItems = filter.school.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolId: { [Op.or]: listItems },
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.school_admins.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('school_admins', 'full_name', query),
        ],
      };
    }

    const records = await db.school_admins.findAll({
      attributes: ['id', 'full_name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['full_name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.full_name,
    }));
  }
};
